프로그래밍 언어 & 프레임워크/Golang

Go: recover() 를 사용하여 복구하기 [Effective Go]

recover() 함수를 사용하여 panic() 에서 어플리케이션을 복구할 때 사용할 수는 몇 가지 기법을 Effective Go 에서 보여주고 있다. 이 포스트에서 이야기해 볼 것은 두 가지, 다수의 고루틴을 돌릴 때 다른 고루틴에게 피해를 주지 않고 실패한 고루틴만 로깅하기패닉, 한 번 더 패닉이다. 패닉과 에러에 대한 기초적인 내용은 다른 포스트에 적은 바 있다.

 

Go: 에러와 패닉 (panic, recover)

 

Go: 에러와 패닉 (panic, recover)

예외가 없다고? 그렇다. Go 언어에는 예외(Exception)가 없다. 에러로 모든 것을 처리한다. error 빌트인 타입은 존재하긴 하지만, 그렇다고 타언어처럼 모든 에러에 대해 타입이 매핑되어 있는 것은

pronist.tistory.com

실패한 고루틴만 로깅하기

각 고루틴이 어떤 조건에 도달하면 패닉을 일으키되, 로깅을 하고 고루틴을 마친다. 정상적으로 종료되는 것이므로 패닉이 발생한 상태를 회복한 것이라 볼 수 있다. 이는 아래와 같이 해볼 수 있다. 해당 고루틴은 랜덤으로 생성한 정수값이 2 로 나누어지면 패닉을 일으키는 단순한 예제다. 

var wg sync.WaitGroup

func doSomething(id int) {
	rand.Seed(int64(id))

	defer func() {
		if err := recover(); err != nil {
			fmt.Fprintf(os.Stderr, "goroutine #%d, got %v, want %v %% 2 != 0\n", id, err, err)
		}
	}()
	defer wg.Done()

	randomInt := rand.Intn(100) + 1
	if randomInt % 2 == 0 {
		panic(randomInt)
	}

	fmt.Println(randomInt)
}

func do() {
	for i := 0; i < 10; i++ {
		wg.Add(1)
		go doSomething(i)
	}
	wg.Wait()
}

do() 함수에서 10개의 고루틴을 만들고, 각 고루틴마다 recover() 를 포함한 지연된 호출을 가지고 있기 때문에 만약 고루틴을 실행하던 도중, 패닉이 발생한다고 해도 다른 고루틴에게는 영향을 주지 않는다. 다음의 예는 해당 프로그램을 실행했을 때의 결과 중 하나다.

9
89
49
87
87
27
75
goroutine #4, got 30, want 30 % 2 != 0
goroutine #1, got 78, want 78 % 2 != 0
goroutine #9, got 2, want 2 % 2 != 0

패닉, 한 번 더 패닉

패닉을 복구시키되 만약 사전에 정의된 패닉이 아니라 예상하지 못한 패닉이라면 패닉을 한 번 더 발생시켜 에러를 처리할 수 있다. 예를 들면 다음과 같이 Error 타입이 있다고 가정했을 때, 해당 타입이 패닉으로 전달되지 않은 경우에는 예상하지 못한 패닉으로 간주하고 패닉을 발생시킬 수 있다.

type Error string

func (e Error) Error() string {
	return string(e)
}

func do() {
	defer func() {
		if err := recover(); err != nil {
			err, ok := err.(Error)
			if !ok {
				panic(err)
			}
			fmt.Fprintf(os.Stderr, err.Error())
		}
	}()
	doSomething()
}

여기서 doSomething() 함수에서 어떤 패닉이 발생하냐에 따라 분기가 달리게 되는데, 다음과 같은 형태로 발생하면 패닉이 아니라 로깅이 정상적으로 이루어진다.

func doSomething() {
	panic(Error("Hello, Go!"))
}

이런 식으로 호출되었을 때, 패닉이 발생하지 않는 이유는, do() 함수의 지연된 호출에서 타입 단언이 성공했기 때문이다. 만약 알려지지 않은 타입이어서 타입 단언이 실패한다면, 다시 한 번 패닉이 발생하게 된다.